/* archimede.c 
   Approssimazione di p_greco col metodo di esaustione di Archimede.
  */
#include <stdio.h>
#include <math.h>
/* Scegli questi dati per partire col quadrato */
#define NINIZ 4
#define LISCR sqrt(2.)
#define LCSCR 2.
#define NVAL 29
/* Scegli questi dati per partire con l'esagono */
/* #define NINIZ 6 */
/* #define LISCR 1 */
/* #define LCSCR (2./sqrt(3.)) */
/* #define NVAL 28 */
/*  */
int main()
{
  double p,q,delta;
  unsigned long n;
  int j;
  n = NINIZ;
  printf("Parto con n=%lu\n\n",n);
  printf("      Lati                Inscritto             Circoscritto          Delta\n");
  p = n*LISCR;
  q = n*LCSCR;
  delta = .5*(q-p);
  printf("%10lu%24.15e%24.15e%15.5e\n",n,.5*p,.5*q,delta);
  for(j=0;j<NVAL;j++) {
    n *= 2;
    q = 2.*q*p/(q+p);
    p = sqrt(q*p);
    delta = .5*(q-p);
    printf("%10lu%24.15e%24.15e%15.5e\n",n,.5*p,.5*q,delta);
  }
  exit(0);
}


