/* mcd : calcola il massimo comun divisore tra due numeri.
   Viene accettata in input qualunque coppia di numeri.
   Il valore restituito e' sempre positivo.
   Se uno solo dei due numeri e' zero viene restituito il 
   valore assoluto del secondo.
   Se ambedue i numeri sono zero viene restituito zero.
 */
long int mcd(j,k)
     long int j;
     long int k;
{
  long int a,b,c;
				/* Prendi i valori assoluti degli argomenti */
  if(j >= 0) a = j; else a = -j;
  if(k >= 0) b=k; else b = -k;
  if(a==0) return(b);		/* Se uno degli argomenti e' nullo */ 
  if(b==0) return(a);		/* restituisci l'altro. */
  if(a<b) {c=a; a=b; b=c;}	/* Metti in ordine : a >= b */
  while((c = a %= b) > 0) {	/* Applica l'algoritmo di Euclide */
    a=b;
    b=c;
  }
  return(b);
}
