/* Calcola e stampa i numeri primi tra 1 e 100.
La tabella e' costruita con il crivello di Eratostene 
nella sua forma piu' banale.
Il programma e' alquanto migliorabile, ma serve solo come esempio
per l'utilizzo di un vettore e di un ciclo for.
*/
#include <stdio.h>
int main()
{
  int primi[101];		/* Alloca il vettore di lunghezza n */
  int n=101;			/* n e' la lunghezza del vettore . La tabella
				   conterra' i numeri da 0 a n-1. */
  int j,k;
  for(j=0; j<n; j++)		/* Comincia col riempire il vettore */
    primi[j]=j;
  for(j=2;j<n/2;j++) {		/* Azzera tutti i multipi di 2,3,...,n/2 */
				/* Il ciclo deve partire da 2j, non da j */
    for(k=j+j;k<n;k=k+j) primi[k]=0;
  }
  for(j=0;j<n;j++)		/* Stampa tutto quello che non e' zero */
    if(primi[j]!=0) printf("%d\n",primi[j]);
  exit(0);
}
