/* leibniz.c 
   Approssimazione di p_greco con la formula dell'arcotangente.
  */
#include <stdio.h>
#include <math.h>
#define NVAL 25
/*  */
int main()
{
  long int j,jfin;
  double x,z,segno,den,pigrec,delta;
  pigrec = 4.*atan(1.);
  segno = den = 1.;
  jfin = 1 << NVAL;
  z = 0.;
  for(j=0;j<=jfin;j++) {
    z += segno/den;
    segno = -segno;
    den += 2.;
    if((j & (j-1)) == 0) { 
      x = 4.*z;
      delta = x-pigrec;
      printf("%12ld %25.16e  %15.7e\n",j,x,delta);
    }
  }
  exit(0);
}


